Qt 5.9 | Qt 3D | C++ Classes | QComponent

Qt 5.9.3 Reference Documentation

# QComponent Class

(Qt3DCore::QComponent)

The base class of scene nodes that can be aggregated by Qt3DCore::QEntity instances as a component. More...

Header: | #include <QComponent>
qmake: | QT += 3dcore
Since: | Qt 5.5
Instantiated By: | Component3D
Inherits: | Qt3DCore::QNode
Inherited By: | Qt3DAnimation::QAbstractClipAnimator, Qt3DCore::QTransform, Qt3DInput::QAxisAccumulator, Qt3DInput::QInputSettings, Qt3DInput::QKeyboardHandler, Qt3DInput::QLogicalDevice, Qt3DInput::QMouseHandler, Qt3DLogic::QFrameAction, Qt3DRender::QAbstractLight, Qt3DRender::QCameraLens, Qt3DRender::QComputeCommand, Qt3DRender::QEnvironmentLight, Qt3DRender::QGeometryRenderer, Qt3DRender::QLayer, Qt3DRender::QLevelOfDetail, Qt3DRender::QMaterial, Qt3DRender::QObjectPicker, Qt3DRender::QRenderSettings, Qt3DRender::QRenderTarget, Qt3DRender::QSceneLoader, and Qt3DRender::QShaderData

- List of all members, including inherited members

## Properties

- isShareable : bool

- 3 properties inherited from Qt3DCore::QNode

## Public Functions

| QComponent(QNode *parent = nullptr)
| ~QComponent()
QVector<QEntity *> | entities() const
bool | isShareable() const

- 11 public functions inherited from Qt3DCore::QNode

## Public Slots

void | setShareable(bool isShareable)

- 3 public slots inherited from Qt3DCore::QNode

## Signals

void | addedToEntity(QEntity *entity)
void | removedFromEntity(QEntity *entity)
void | shareableChanged(bool isShareable)

- 4 signals inherited from Qt3DCore::QNode

### Additional Inherited Members

- 2 protected functions inherited from Qt3DCore::QNode

## Detailed Description

The base class of scene nodes that can be aggregated by Qt3DCore::QEntity instances as a component.

A Qt3DCore::QComponent provides a vertical slice of behavior that can be assigned to and sometimes shared across Qt3DCore::QEntity instances.

Qt3DCore::QComponent subclasses are often aggregated in groups that impart useful behavior to the aggregating entity. For example, to have an Entity that gets drawn by the Qt3D renderer aspect, an entity would most likely aggregate Qt3DCore::QTransform, Qt3DRender::QMesh, and Qt3DRender::QMaterial components.

See also Qt3DCore::QEntity.

## Property Documentation

### isShareable : bool

Holds the shareable flag of the QComponent. The QComponent can be shared across several entities if `true`.

Access functions:

bool | isShareable() const
void | setShareable(bool isShareable)

Notifier signal:

void | shareableChanged(bool isShareable)

## Member Function Documentation

### QComponent::QComponent(QNode *parent = nullptr)

Constructs a new QComponent instance with parent as the parent.

Note: a QComponent should never be instanced directly, instance one of the subclasses instead.

### QComponent::~QComponent()

Destroys the instance of QComponent.

### `[signal]` void QComponent::addedToEntity(QEntity *entity)

### QVector<QEntity *> QComponent::entities() const

Returns a QVector containing all the entities that reference this component.

### `[signal]` void QComponent::removedFromEntity(QEntity *entity)